/**
 * Receiver Main
 * C++ PL
 * 
 * Author :  Nikhil
 * Version 4.0
 **/

#include <iostream>
#include <fstream>
//#include <conio.h>/
//#include <process.h>
#include <string.h>
#include <sys/time.h>
//#include <sys/types.h>
#include <sys/stat.h>
#include <unistd.h>
#include <fcntl.h>
//#include <math.h>
#include <sys/ioctl.h>
#include <linux/soundcard.h>
//#define metre 1
//#define foot 2
//#define N 5

using namespace std;

const unsigned int SAMPLING_RATE = 48000;
const unsigned int BLOCK_TIME = 20;
const unsigned int BLOCK_SIZE = SAMPLING_RATE*BLOCK_TIME/1000;
const unsigned int BUF_BLOCKS = 128;
const double silence_thresh = 2.3;

int units;
double length, width;
char f, s;

int audio_fd;

short rec_buf[BLOCK_SIZE];

/**
 * Vars for gettiemofday function
 **/
struct timeval temp, temp3;
struct timezone tzp;
//ofstream fdes;

int lastBlockSound = 0;

int main (int argc, char **argv)
{
	ofstream fdes("rtime.txt");/*, ios::out | ios::in);*/
	/*if (fdes == NULL)
		cout << "ERROR";*/
	/* A 20 millisec Timeval */
	struct timeval diff;
	diff.tv_sec = 0;
	diff.tv_usec = 14000;
	int audio_fd = -1;
	printf("BLOCK SIZE : %d\n", BLOCK_SIZE);

	/* OPEN AUDIO */
	if ((audio_fd = open("/dev/dsp", O_RDONLY, 0)) == -1)
		cout << "Error opening audio device" << endl;
	int format;
	format = AFMT_S16_LE;
	if (ioctl(audio_fd, SNDCTL_DSP_SETFMT, &format) == -1 || format != AFMT_S16_LE)
		cout << "Error setting sample format or format not supported" << endl;
	int speed  = 48000;		// CHANGED
	if (ioctl(audio_fd, SNDCTL_DSP_SPEED, &speed) == -1 || speed != 48000)// CHANGED TO 48 kHz
		cout << "Error setting sampling rate or rate not supported" << endl;
	//fflush((FILE *)&audio_fd);*/

	
	/* Read Audio indefinitely */
	while (1)
	{
		/* Get value by hit and trial */
		//double silence_thresh = 6;
	//int audio_fd = -1;
	
/*	audio_fd = -1;
	if ((audio_fd = open("/dev/dsp", O_RDONLY, 0)) == -1)
		cout << "Error opening audio device" << endl;
	int format;
	format = AFMT_S16_LE;
	if (ioctl(audio_fd, SNDCTL_DSP_SETFMT, &format) == -1 || format != AFMT_S16_LE)
		cout << "Error setting sample format or format not supported" << endl;
	int speed  = 48000;		// CHANGED
	if (ioctl(audio_fd, SNDCTL_DSP_SPEED, &speed) == -1 || speed != 48000)// CHANGED TO 48 kHz
		cout << "Error setting sampling rate or rate not supported" << endl;
	//fflush((FILE *)&audio_fd);*/

	test:	
		bzero(rec_buf, BLOCK_SIZE);
		//gettimeofday(&temp, &tzp);
		if (read(audio_fd, rec_buf, BLOCK_SIZE) == -1)
		{
			cout << "Reading audio from device failed\n";
			return -1;
		}
		gettimeofday(&temp/*3*/, &tzp);

		/* Check if silence */
		int sum = 0;
		int temp2 = 0;
		for (int i = 0; i < BLOCK_SIZE; i++)
		{
			temp2 = rec_buf[i];
			sum += abs(temp2);
		}
		double en = sum / BLOCK_SIZE;
		en = log10(en);
		//cout << "\nAvg energy = " << en;

		if (en < silence_thresh) /* This is a silence block */
		{
			lastBlockSound = 0;
			//cout << "\nSILENCE BLOCK";
			//continue;
			goto test;
		}
		else
		{
			if (lastBlockSound == 1)
				continue;
			//cout << "\nNew Signal";
			/* Subtract 20 ms */
			/* I hope this works :D */
			temp.tv_usec = temp.tv_usec - diff.tv_usec;
			if (temp.tv_usec < 0)
			{
				--(temp.tv_sec);
				(temp.tv_usec) += 1000000;
			}
			cout << "\nReceive Time :\n";
			cout << "Secs : " << temp.tv_sec 
				<< "\tUSecs : " << temp.tv_usec << "\n\n";
			//fdes.write((char *)&temp.tv_sec, sizeof(temp.tv_sec));
			//fdes.write((char *)&temp.tv_usec, sizeof(temp.tv_usec));
			fdes << temp.tv_sec <<endl;
			fdes << temp.tv_usec<<endl;
			/*cout << "\nDiff : ";
			cout << temp3.tv_usec - temp.tv_usec << "\n";*/
			lastBlockSound = 1;
		}
		//close(audio_fd);
		sleep(4);
		//usleep(700000);
		/* Flush buffer by reading from it 20 times */
		int d = 0;
		while (d < 20)		
		{
		bzero(rec_buf, BLOCK_SIZE);
		if (read(audio_fd, rec_buf, BLOCK_SIZE) == -1)
		{
			cout << "Reading audio from device failed\n";
			return -1;
		}
		d++;
		}
		usleep(500000);

	}
	fdes << flush;
	fdes.close();
}
